<div class="content">
  <form [formGroup]="trainingInstanceFormGroup.formGroup">
    <!--TITLE field-->
    <mat-form-field appearance="outline" (keydown.enter)="$event.preventDefault()">
      <mat-label>Title</mat-label>
      <input matInput placeholder="Title" formControlName="title" required />
      <button *ngIf="title.value" matSuffix mat-icon-button aria-label="Clear" (click)="title.setValue('')">
        <mat-icon>close</mat-icon>
      </button>
      <mat-error *ngIf="title.hasError('whitespace')">This field is required</mat-error>
    </mat-form-field>

    <div class="panel-wrapper">
      <div class="left-panel">
        <!-- START TIME field -->
        <mat-form-field
          class="multi-line-hint"
          hintLabel="When trainees can access training runs (if left empty, the current time will be set as the start time)"
          [owlDateTimeTrigger]="startTimePicker"
          appearance="outline"
        >
          <mat-label>Start Time</mat-label>
          <div class="input-wrapper">
            <input
              matInput
              placeholder="Start Time"
              [min]="now"
              [max]="endTime.value"
              formControlName="startTime"
              [owlDateTime]="startTimePicker"
            />
            <owl-date-time #startTimePicker [startAt]="startTime.value"></owl-date-time>
          </div>
          <mat-error *ngIf="trainingInstanceFormGroup.formGroup.hasError('startTimeAfterEndTime')"
            >Start time must be before end time</mat-error
          >
          <mat-error *ngIf="startTime.hasError('dateInPast')">Start time cannot be in the past</mat-error>
          <mat-error *ngIf="startTime.hasError('required')">This field is required</mat-error>
        </mat-form-field>

        <!-- END TIME field -->
        <mat-form-field
          class="multi-line-hint"
          hintLabel="Trainees cannot access training runs after end time
          expires"
          [owlDateTimeTrigger]="endTimePicker"
          appearance="outline"
        >
          <mat-label>End Time</mat-label>
          <div class="input-wrapper">
            <input
              matInput
              placeholder="End Time"
              required
              [min]="startTime.value"
              formControlName="endTime"
              [owlDateTime]="endTimePicker"
            />
            <owl-date-time #endTimePicker [startAt]="endTime.value ? endTime.value : startTime.value"></owl-date-time>
          </div>
          <mat-error *ngIf="trainingInstanceFormGroup.formGroup.hasError('startTimeAfterEndTime')"
            >Start time must be before end time</mat-error
          >
          <mat-error *ngIf="endTime.hasError('dateInPast')">End time cannot be in the past</mat-error>
          <mat-error *ngIf="endTime.hasError('required')">This field is required</mat-error>
        </mat-form-field>
      </div>

      <div class="right-panel">
        <!-- ACCESS TOKEN filed -->
        <mat-form-field
          appearance="outline"
          class="multi-line-hint"
          (keydown.enter)="$event.preventDefault()"
        >
          <mat-label>Access Token Prefix</mat-label>
          <input matInput placeholder="Access Token" formControlName="accessTokenPrefix" required />
          <button
            *ngIf="accessTokenPrefix.value"
            matSuffix
            mat-icon-button
            aria-label="Clear"
            [disabled]="hasStarted"
            (click)="accessTokenPrefix.setValue('')"
          >
            <mat-icon>close</mat-icon>
          </button>
          <mat-hint *ngIf="!editMode">Generated PIN code will be added to your token</mat-hint>
          <mat-hint *ngIf="editMode">Whenever you change the access token a new PIN will be generated</mat-hint>
          <mat-error *ngIf="accessTokenPrefix.hasError('whitespace')">This field is required</mat-error>
        </mat-form-field>

        <!-- TRAINING DEFINITION field-->
        <div class="form-line">
          <p *ngIf="trainingDefinition.value">
            Training Definition:
            {{ trainingDefinition.value.title | sentinelShortString: 30 }}
          </p>
          <p *ngIf="!trainingDefinition.value">Training Definition*</p>
          <button (click)="selectTrainingDefinition()" [disabled]="hasStarted" mat-button color="accent">Select</button>
        </div>
      </div>
    </div>

    <div class="slide-toggle-container">
      <span>Local Environment</span>
      <mat-slide-toggle
        [matTooltip]="
          localEnvironment
            ? 'Enable Local Environment to disable the pool selection.'
            : 'Disable Local Environment to enable the pool selection.'
        "
        formControlName="localEnvironment"
      >
      </mat-slide-toggle>
    </div>

    <div class="slide-toggle-container">
      <span>Backward Mode</span>
      <mat-slide-toggle
        [matTooltip]="
          backwardMode
            ? 'Enable Backward Mode to allow trainees move to previous accessed levels during training run.'
            : 'Disable Backward Mode to disallow trainees move to previous accessed levels during training run.'
        "
        formControlName="backwardMode"
      >
      </mat-slide-toggle>
    </div>
  </form>
</div>
